<?php
/**
 * @copyright elise
 */

// make sure we are not being called directly
defined('APP_DIR') or exit();

/**
 * meta
 */
function xxAutoNotify_meta()
{
    $_tmp = array(
        'name'        => 'Auto Notify',
        'url'         => 'autonotify',
        'version'     => '1.0.0',
        'developer'   => 'elise' . strftime('%Y'),
        'description' => 'A listener module. Upon user registration, auto notify on forum posts in specified categories',
        'category'    => 'custom',
        'requires'    => 'jrForum',
        'license'     => 'jcl'
    );
    return $_tmp;
}

/**
 * init
 */
function xxAutoNotify_init()
{
    // Event Listener
    jrCore_register_event_listener('jrUser', 'signup_activated', 'xxAutoNotify_signup_activated_listener');

    return true;
}

//----------------------
// EVENT LISTENERS
//----------------------

/**
 * Listen for the 'signup_activated' event and add user as watcher of forum category
 * @param $_data array incoming data array
 * @param $_user array current user info
 * @param $_conf array Global config
 * @param $_args array additional info about the module
 * @param $event string Event Trigger name
 * @return array
 */
function xxAutoNotify_signup_activated_listener($_data, $_user, $_conf, $_args, $event)
{
    if (jrCore_db_table_exists('jrForum', 'follow_category')) {
        if (isset($_conf['xxAutoNotify_category_id']) && strlen($_conf['xxAutoNotify_category_id']) > 0) {
            $cid = (int) $_conf['xxAutoNotify_category_id'];
            $uid = (int) $_data['_user_id']; // we use the data _user_id because it may be the ADMIN user clicking the APPROVE button.
            $tbl = jrCore_db_table_name('jrForum', 'follow_category');
            $req = "INSERT IGNORE INTO {$tbl} (follow_cat_id,follow_user_id) VALUES ('{$cid}','{$uid}')";
            jrCore_db_query($req);

            // reset forum cache for this user
            jrCore_delete_all_cache_entries('jrForum', $_user['_user_id']);

        }
    }
    return $_data;
}